package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10021ReqBean16;
import cn.net.cpzslibs.prot.bean.res.Prot10021ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10021ProductInfo extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10021 = 10021;
	private Gson gson;
	private Prot10021ResBean productInfoResult;
	
	public Prot10021ProductInfo() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10021ResBean getProductInfoResult(){
		return this.productInfoResult;
	}
	
	public void dealProductInfo(SocketCreate create, Prot10021ReqBean16 reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10021ReqBean16 reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10021, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10021, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10021, jsonData);
//		[{"companyName":"云南云天化股份有限公司","companyTel":"0870-8662731","companyUrl":"https://www.baidu.com/","consumeCode":"9762","description":"云天化","name":"复合肥","origin":"中国云南省","producer":"云南云天化股份有限公司","productId":"100002","productUrl":"","query_des":"磷肥"}]
//		JSONObject object1 = new JSONObject(content);
		if (!StrUtils.isEmpty(jsonData)) {
			productInfoResult = gson.fromJson(jsonData, Prot10021ResBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10021ReqBean16 reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10021, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
